-----------------------------------------------------------------------------------------------
-- Client Lua Script for AvatusHelper
-- Copyright (c) NCsoft. All rights reserved
-- Some code/ideas was taken from Maat's OhmnaKnockbackAssist addon
-- 
-------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- AvatusHelper Module Definition
-----------------------------------------------------------------------------------------------
local AvatusHelper = {} 
local version = 20
local sin = math.sin
local cos =  math.cos
local rad = math.rad


	local posname = {}
	posname[1] = "NE"
	posname[2] = "SE"
	posname[3] = "SW"
	posname[4] = "NW"
	posname[5] = "SE"
	posname[6] = "SW"
	posname[7] = "N"
	
	
	local colors = {}
	colors[1] ="ff00ff00"
	colors[2] ="ff00ff00"
	colors[3] ="ff00ff00"
	colors[4] ="ff00ff00"
	colors[5] ="ffffff80"
	colors[6] ="ffffff80"
	colors[7] ="ffffff80"
	
	local sprites = {}
	sprites[1] = "achievements:sprAchievements_Icon_Group"
	sprites[2] = "achievements:sprAchievements_Icon_Group"
	sprites[3] = "achievements:sprAchievements_Icon_Group"
	sprites[4] = "achievements:sprAchievements_Icon_Group"
	sprites[5] = "Crafting_RunecraftingSprites:sprRunecrafting_Omni"
	sprites[6] = "Crafting_RunecraftingSprites:sprRunecrafting_Omni"
	sprites[7] = "Crafting_RunecraftingSprites:sprRunecrafting_Omni"

local LocalesNames = {
	["Avatus"] = {
		[1] = "Avatus",
		[2] = "Avatus",
		[3] = "Avatus",
		[99] = "Raid Target Dummy",  --For Testing
	},
	["Holo Hand"] = {
		[1] = "Holo Hand",
		[2] = "Holo Hand",
		[3] = "Holo Hand",
		[99] = "Raid Target Dummy",  --For Testing
	},
	["Fragmented Data Chunk"] = {
		[1] = "Fragmented Data Chunk",
		[2] = "Fragmented Data Chunk",
		[3] = "Fragmented Data Chunk",
		[99] = "Raid Target Dummy",  --For Testing
	},
	["Holo Cannon"] = {
		[1] = "Holo Cannon",
		[2] = "Holo Cannon",
		[3] = "Holo Cannon",
		[99] = "Raid Target Dummy",  --For Testing
	},
	["Lateral Shot Cannon"] = {
		[1] = "Lateral Shot Cannon",
		[2] = "Lateral Shot Cannon",
		[3] = "Lateral Shot Cannon",
		[99] = "Raid Target Dummy",  --For Testing
	},
	["Crushing Blow"] = {
		[1] = "Crushing Blow",
		[2] = "Crushing Blow",
		[3] = "Crushing Blow",
		[99] = "Raid Target Dummy",  --For Testing
	},
	["Strikethrough"] = {
		[1] = "Strikethrough",
		[2] = "Strikethrough",
		[3] = "Strikethrough",
		[99] = "Raid Target Dummy",  --For Testing
	},
	["Obliteration Beam"] = {
		[1] = "Obliteration Beam",
		[2] = "Obliteration Beam",
		[3] = "Obliteration Beam",
		[99] = "Obliteration Beam",  --For Testing
	},

}




----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function AvatusHelper:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function AvatusHelper:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- AvatusHelper OnLoad
-----------------------------------------------------------------------------------------------
function AvatusHelper:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("AvatusHelper.xml")
	Apollo.LoadSprites("OHSprite.xml","OHSprite")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- AvatusHelper OnDocLoaded
-----------------------------------------------------------------------------------------------
function AvatusHelper:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.Overlay = Apollo.LoadForm(self.xmlDoc, "Overlay", "InWorldHudStratum", self)
	    self.PopUp = Apollo.LoadForm(self.xmlDoc, "OHPopUp", nil, self)
		if self.Overlay == nil then
		Print("Error")
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
	    self.PopUp:Show(false, true)
	    self.Overlay:Show(true)
		
		self.debug = false
		
		Apollo.RegisterEventHandler("UnitEnteredCombat", "OnEnteredCombat", self)
		if self.debug then
			Apollo.RegisterEventHandler("NextFrame", "OnNextFrame", self)
		end
    	Apollo.RegisterSlashCommand("ahelper", "OnOptions", self)
		Apollo.RegisterEventHandler("UnitCreated", "OnUnitCreated", self)
		--Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
--		Apollo.RegisterEventHandler("InterfaceClick", "OnInterfaceClick", self)

		self.lineWidth = 4
		self.lineLength = 32
		
		self.OptionsButton = self.PopUp:FindChild("OptionsButton")
		self.OptionsPopUp = self.PopUp:FindChild("OptionsWindow")
		self.OptionsButton:AttachWindow(self.OptionsPopUp)
		
		self.watchList = {}
		
		self:FillOptionsWindow()
		self:OnSettingChange()
		self.Resolution = 5
		-- Locale Check
		local strCancel = Apollo.GetString(1)
		if strCancel == "Abbrechen" then
			self.Locale = 2
		elseif strCancel == "Annuler" then
			self.Locale = 3
		else
			self.Locale = 1
		end

		self.player = GameLib.GetPlayerUnit()
		if self.debug then  self:CheckWatchList(self.player) end
	end
end

function AvatusHelper:OnInterfaceMenuListHasLoaded()
		Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "AvatusHelper", {"InterfaceClick", "", ""})
end

function AvatusHelper:OnInterfaceClick()
	self:OnOptions()
end



-----------------------------------------------------------------------------------------------
-- AvatusHelperForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function AvatusHelper:OnOK()
	self.PopUp:Close() -- hide the window
	self.OptionsButton:SetCheck(false)
end

-- when the Cancel button is clicked
function AvatusHelper:OnCancel()
	self.PopUp:Close() -- hide the window
	self.OptionsButton:SetCheck(false)
end


function AvatusHelper:OnOptions()
	if not self.PopUp:IsVisible() then
		self.PopUp:Invoke()
	else
		self:OnCancel()
	end

end
---------------------------------------------------------------------------------------------------
-- OHPopUp Functions
---------------------------------------------------------------------------------------------------

function AvatusHelper:OnSettingChange( wndHandler, wndControl, eMouseButton )
	self.enableGunGrid = self.PopUp:FindChild("GunGridButton"):IsChecked()
	self.enableHands = self.PopUp:FindChild("ShowHandsButton"):IsChecked()
	self.KSlider = self.PopUp:FindChild("KSliderBar"):GetValue()
	
	self.PopUp:FindChild("SliderValue"):SetText(self.KSlider)
	--self.PopUp:FindChild("SliderWindow"):Show(self.enableGunGrid)
end


function AvatusHelper:ClearMarks( wndHandler, wndControl, eMouseButton )
	self:OnSettingChange()

end

function AvatusHelper:OnOptionsBtn( wndHandler, wndControl, eMouseButton )
end

-----------------------------------------------------------------------------------------------
-- AvatusHelper Instance
-----------------------------------------------------------------------------------------------
local AvatusHelperInst = AvatusHelper:new()
AvatusHelperInst:Init()


function AvatusHelper:OnNextFrame()
	self.player = GameLib.GetPlayerUnit()
	
	if self.player == nil then return end
	
	self.Overlay:DestroyAllPixies()

	if not self.debug and not self.player:IsInCombat() then
	  	Apollo.RemoveEventHandler("NextFrame",self)
		self.watchList = nil 
		self.watchList = {}
		return
	end
	
	local currentlist = self.watchList
	self.watchList = {}
	
	for k, v in pairs(currentlist) do
	local Vname = v:GetName()
--		self:SetupLines(v,false)
	
		if v:IsValid() then
			self.watchList[k]=v
		end
		if v:IsValid() and Vname == self:GetLocaleName("Avatus") then
			self:SetupLines(v,true)
		elseif self.enableHands and v:IsValid() and Vname == self:GetLocaleName("Fragmented Data Chunk") then
			self:SetupLines(v,false)
			self:DrawPixie(v)
		elseif self.enableHands and v:IsValid() and Vname == self:GetLocaleName("Holo Hand") then
			self:SetupLines(v,false)
			self:DrawPixie(v)
		elseif Vname == "Mobius Physics Constructor" then
			self:DrawPixie(v)
		elseif self.enableGunGrid and v:IsValid() and Vname == (self:GetLocaleName("Holo Cannon") or  self:GetLocaleName("Lateral Shot Cannon")) then
			self:DrawPixieLine(v,100,"e600000ff")
		elseif v:IsValid() and Vname == self.player:GetName() and v ~= self.player then
			local vpos = v:GetPosition()
			local posV = Vector3.New(vpos.x,vpos.y,vpos.z)
			local pos = GameLib.WorldLocToScreenPoint(posV)
			local playerPos = self.player:GetPosition()
			local posbT = Vector3.New(playerPos.x,playerPos.y,playerPos.z)
			local posb = GameLib.WorldLocToScreenPoint(posbT)
			self.Overlay:AddPixie( { bLine = true, fWidth = 3,  cr = "ffffffff", loc = { fPoints = {0,0,0,0}, nOffsets = { pos.x, pos.y, posb.x, posb.y } }    } )
		end
	end	
end


function AvatusHelper:DrawPixieLine(v,dist,color)
	if color == nil then
		color = "e60ff0000"
	end
	local tface = v:GetFacing()
	if tface == nil then return end
	
	local tangle = math.atan2(tface.x, tface.z)
	local tpos = v:GetPosition()
	local tposV = Vector3.New(tpos.x,tpos.y,tpos.z)
	local dist = 100
	self:SimpleLine(tposV,dist,tangle + rad(0),10,color)
end


function  AvatusHelper:DrawPixie(v)
	local vpos = v:GetPosition()
	local newPos = Vector3.New(vpos.x,vpos.y,vpos.z)
	local pos = GameLib.WorldLocToScreenPoint(newPos)

	local size = 20
	
	self.Overlay:AddPixie( {
	strText ="", strSprite = "CRB_GuildSprites:sprGuild_ZombieHand_Stretchable", cr = "ffff0000",
	loc = {fPoints = pixieLocPoints, nOffsets = {pos.x-size ,pos.y-size, pos.x+size, pos.y+size  } }
      } )

end

function AvatusHelper:DrawHelpers()
end

--- Knockback assist starter
function AvatusHelper:OnEnteredCombat(unit, bInCombat)
	--if GetCurrentZoneName() ~= "Genetic Archives - Act 2" then return end
	if unit and unit:GetType() ~= "NonPlayer" then return end
	local uName = unit:GetName()
	if uName == self:GetLocaleName("Avatus") then
		Apollo.RegisterEventHandler("NextFrame", "OnNextFrame", self)
		self:CheckWatchList(unit)
	end
end

function AvatusHelper:OnUnitCreated(unit)
	if unit and unit:GetType() ~= "NonPlayer" then return end
	local uName = unit:GetName()
		
	if uName == self:GetLocaleName("Avatus") or uName == self:GetLocaleName("Holo Hand") or uName == self:GetLocaleName("Holo Cannon") or uName == self:GetLocaleName("Fragmented Data Chunk")then
		self:CheckWatchList(unit)
	end
	
	if uName ~= "Phantom" and uName ~="Figment" and uName ~="Holo Cannon" then
		--Print(uName)
	end
	
	if self.player and uName == self.player:GetName() and unit ~= self.player then
		--Print("found")
		--self:CheckWatchList(unit)
	end	
				 
	if uName == "Mobius Physics Constructor" then
		--Print("created")
		--self:CheckWatchList(unit)
	end	
	
	
end

function AvatusHelper:GetLocaleName(name)
--	self.Locale = 99 -- For Testing
	if LocalesNames[name] ~= nil then
		return LocalesNames[name][self.Locale]
	end
	return false
end


function AvatusHelper:CheckWatchList(unit)
	if not self.watchList[unit:GetId()] then
		self.watchList[unit:GetId()] = unit
	end
end


function AvatusHelper:OnSave(eLevel)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	local tsave = {}
	tsave.KSlider = self.KSlider
	tsave.enableGunGrid = self.enableGunGrid
	tsave.enableHands = self.enableHands
	return tsave
end


function AvatusHelper:OnRestore(eLevel, saveData)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	for k,v in pairs(saveData) do
	   	self[k]=v
	end
end


function AvatusHelper:FillOptionsWindow()
	self.PopUp:FindChild("KSliderBar"):SetValue(self.KSlider or 10)
	self.PopUp:FindChild("SliderValue"):SetText(self.KSlider or 10)
	self.PopUp:FindChild("GunGridButton"):SetCheck(self.enableGunGrid or false)
	if self.enableHands ~= nil then
		self.PopUp:FindChild("ShowHandsButton"):SetCheck(self.enableHands)
	end
end


-- Line Plotting
function AvatusHelper:SetupLines(targ,avatus)

	if targ:IsDead() or not targ:IsValid() then	return end
	
	local tface = targ:GetFacing()

	local tangle = math.atan2(tface.x, tface.z)
	--local leftV = tangle + rad(45)
	--local rightV = tangle + rad(-45)

	
	
	local tpos = targ:GetPosition()
	local tposV = Vector3.New(tpos.x,tpos.y,tpos.z)
	local tposF	
	if not avatus then 
		local nOffsetDegree = tangle+math.rad(180)
		local ntposV =  { x = tposV.x+2*math.sin(nOffsetDegree) , y = tposV.y , z = tposV.z+2*math.cos(nOffsetDegree) }
		local ntposFV =  { x = tposV.x-11*math.sin(nOffsetDegree) , y = tposV.y , z = tposV.z-11*math.cos(nOffsetDegree) }
		tposF = Vector3.New(ntposFV.x,ntposFV.y,ntposFV.z)
		tposV = Vector3.New(ntposV.x,ntposV.y,ntposV.z)
	end

	

	local frontColor = "80ff0000"
	local sideColor = "bfffff00"
	local sizeMod = self.KSlider
	
	local dist = self.lineLength
	
	local showback = true
	local casting = false
	
	if not avatus then
		dist = 7
		showback = false
	end
	
	
	if targ:IsCasting() then
		local spell = targ:GetCastName()
		if avatus and spell == self:GetLocaleName("Obliteration Beam") then
			
			self:SimpleLine(tposV,dist,tangle + rad(90),30,"e60ff0000")
			self:SimpleLine(tposV,dist,tangle + rad(-90),30,"e60ff0000")
			
			showback = true
			casting = true
		elseif not avatus and spell == self:GetLocaleName("Crushing Blow") then
			sizeMod = 15
			frontColor ="ffffffff"
		elseif not avatus and spell == self:GetLocaleName("Strikethrough") then
		return end
	end		
	
	--regular side markers
	if not casting then
		if avatus then
			self:SimpleLine(tposV,dist,tangle + rad(35),sizeMod,frontColor)
			self:SimpleLine(tposV,dist,tangle + rad(-35),sizeMod,frontColor)
		else -- Hands
			if self.enableHands then
			local handdist = 15
				local one = self:SimpleLine(tposV,handdist,tangle + rad(63),sizeMod,frontColor,true)
				local two = self:SimpleLine(tposV,handdist,tangle + rad(-63),sizeMod,frontColor,true)
			
				local EndA = Vector3.New(tposV.x+handdist*sin(tangle + rad(-63)), tposV.y, tposV.z+handdist*cos(tangle + rad(-64)))
				local EndB = Vector3.New(tposV.x+handdist*sin(tangle + rad(63)), tposV.y, tposV.z+handdist*cos(tangle + rad(64)))
		
				self:DrawLine(EndA, tposF, frontColor,sizeMod)
				self:DrawLine(EndB, tposF, frontColor,sizeMod)
			end
		end
	end
	
	if avatus and showback then
		--Back lines
		self:SimpleLine(tposV,dist,tangle + rad(120),sizeMod,sideColor)
		self:SimpleLine(tposV,dist,tangle + rad(-120),sizeMod,sideColor)
	end		
end


function AvatusHelper:SimpleLine(tposV,dist,vect,sizeMod,color,noOffset)
	local End = Vector3.New(tposV.x+dist*sin(vect), tposV.y, tposV.z+dist*cos(vect))
	local Offset
	
	if not noOffset then
		Offset = Vector3.InterpolateLinear(End, tposV, 0.90)
	else
		Offset = tposV
	end
	
	self:DrawLine(End, Offset, color,sizeMod)
	return End
end


--Line Drawing
function AvatusHelper:DrawLine(startV, endV, col, sizeMod)
	local startPoint = GameLib.WorldLocToScreenPoint(startV)
	local endPoint = GameLib.WorldLocToScreenPoint(endV)
	self.Overlay:AddPixie( { bLine = true, fWidth = sizeMod or 2, cr = col, loc = { fPoints = { 0, 0, 0, 0 }, nOffsets = { startPoint.x, startPoint.y, endPoint.x, endPoint.y } } })
end


function AvatusHelper:OnOptionsBtn( wndHandler, wndControl, eMouseButton )
	 local OptionWindow = self.PopUp:FindChild("OptionsWindow")
	 OptionWindow:Show(not OptionWindow:IsShown())
end
